#include <avr/io.h>
#include <avr/interrupt.h>

#include <stdlib.h>
#include <stdint.h>


// --------------------------------------------------------
// Bit-Macros
// --------------------------------------------------------

#define sbit(_port, _bit)	_port |= _BV(_bit)
#define cbit(_port, _bit)	_port &= ~_BV(_bit)

#ifndef SBIT
struct bits {
  uint8_t b0:1;
  uint8_t b1:1;
  uint8_t b2:1;
  uint8_t b3:1;
  uint8_t b4:1;
  uint8_t b5:1;
  uint8_t b6:1;
  uint8_t b7:1;
} __attribute__((__packed__));

#define SBIT_(port,pin) ((*(volatile struct bits*)&port).b##pin)
#define	SBIT(x,y)	SBIT_(x,y)
#endif

#define DDRB0	SBIT(DDRB, 0)
#define PORTB0	SBIT(PORTB, 0)

const uint32_t frequenz = 999999ul;

#define timerTick_500ns()	0

extern int main (void) __attribute__((OS_main));
int main(void)
{
  // Port auf Ausgabe
  PORTB0 = 0;
  DDRB0 = 1;

  uint32_t freq = 0;

  for (;;) {
    freq = freq + frequenz;

    if ( freq >= 2000000ul )
      freq = freq - 2000000ul;

    if ( freq > 1000000ul ) PORTB0 = 1; PORTB0 =0;

    // while (! timerTick_500ns() );
  }

}
